From d38eace17a24ed2d15a3bf069e1aaf05a495e077 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Mattias=20Engdeg=C3=A5rd?= <mattiase@acm.org>
Date: Mon, 16 Aug 2021 19:57:34 +0200
Subject: [PATCH] Fix marker traversion in encode_coding_object

* src/coding.c (encode_coding_object): Only traverse markers if we are
encoding to and from buffers, and use the right buffer when doing so.

This also fixes a performance problem when running in a terminal and
the displayed buffer has many markers (bug#49127).
Reported by Victor Nawothnig.
---
 src/coding.c | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

diff --git a/src/coding.c b/src/coding.c
index 87b55aecc0..599ed48b2e 100644
--- a/src/coding.c
+++ b/src/coding.c
@@ -8275,11 +8275,11 @@ encode_coding_object (struct coding_system *coding,
 
   attrs = CODING_ID_ATTRS (coding->id);
 
-  if (EQ (src_object, dst_object))
+  if (EQ (src_object, dst_object) && BUFFERP (dst_object))
     {
       struct Lisp_Marker *tail;
 
-      for (tail = BUF_MARKERS (current_buffer); tail; tail = tail->next)
+      for (tail = BUF_MARKERS (XBUFFER (dst_object)); tail; tail = tail->next)
 	{
 	  tail->need_adjustment
 	    = tail->charpos == (tail->insertion_type ? from : to);
-- 
2.21.1 (Apple Git-122.3)

